// Fonction exponentielle rapide
function p=exprapide(a,n)
  p=1
  b=a
  m=n
  while m<>0
    if impair(m) then
      p=p*b
    end
    b=b*b
    m=quotient(m,2)
  end
endfunction



// Version matricielle
function F=Fib(n)
  if n<2 then 
    F=1
  else
    x=[0 1;1 1]
    y=[1;1]
    x=exprapide(x,n-1)
    y=x*y
    F=y(2,1)
  end
endfunction




//inf=1
//sup=20
//for i=inf:sup
//  tic()
//  for j=1:1000
//    F=Fib(5*i)
//  end
//  t=toc()
//  afficher([i,F,t])
//end
//



//inf=1
//sup=15
//for i=inf:sup
//  tic()
//  for j=1:1000
//    Fib(10^i)
//  end
//  afficher(toc())
//end



sup=15
//nettoyage du tableau des temps entre deux exécutions
temps=zeros(1,sup)
//début des mesures
for i=1:sup
  //temps de calcul
  tic()
  for j=1:1000
    Fib(10^i)
  end
  temps(i)=toc()
end
//nettoyage de la fenêtre graphique  
clf
//affichage de la courbe
plot(temps) 


