// Version itérative
function F=Fib(n)
  if n<2 then 
    F=1
  else
    x=1
    y=1
    for i=2:n
      temp=x+y
      x=y
      y=temp
    end
    F=y
  end
endfunction



// Les mesures précédentes ne sont plus pertinentes
//inf=10
//sup=29
//for i=inf:sup
//  tic()
//  F=Fib(i)
//  t=toc()
//  afficher([i,F,t])
//end



//inf=1
//sup=20
//for i=inf:sup
//  tic()
//  for j=1:1000
//    F=Fib(5*i)
//  end
//  t=toc()
//  afficher([i,F,t])
//end



sup=20
//nettoyage du tableau des temps entre deux exécutions
temps=zeros(1,sup)
//début des mesures
for i=1:sup
//temps de calcul
  tic()
  Fib(10000*i)
  temps(i)=toc()
end
//nettoyage de la fenêtre graphique  
clf
//affichage de la courbe
plot(temps,"-*r") 